using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.Runtime.CompilerServices;
using System.IO;
using System.Threading.Tasks;
using ReportWriterSample.Droid.Print;
using Xamarin.Forms;
using Java.IO;

[assembly: Xamarin.Forms.Dependency(typeof(DependencyServiceDroid))]
namespace ReportWriterSample.Droid.Print
{
    public class DependencyServiceDroid : IDependencyServiceInterface
    {
        public async Task<bool> PrintPdfAsync(MemoryStream stream)
        {
            throw new NotImplementedException();
        }

        public async Task<bool> SavePdfAsync(MemoryStream stream)
        {
            //var directory = global::Android.OS.Environment.ExternalStorageDirectory.AbsolutePath;
            //directory = Path.Combine(directory, Android.OS.Environment.DirectoryDownloads);
            //string filePath = Path.Combine(directory.ToString(), "sample.pdf");
            //System.IO.File.WriteAllBytes(filePath, stream.ToArray());

            ////Open the Pdf file with Defualt app.
            //Android.Net.Uri pdfPath = Android.Net.Uri.FromFile(new Java.IO.File(filePath));
            //Intent intent = new Intent(Intent.ActionView);
            //intent.SetDataAndType(pdfPath, "application/pdf");
            //intent.SetFlags(ActivityFlags.NewTask);
            //Forms.Context.StartActivity(intent);

            string fileName = "sample.pdf";

            string root = null;

            if (Android.OS.Environment.IsExternalStorageEmulated)
            {
                root = Android.OS.Environment.ExternalStorageDirectory.ToString();
            }
            else
            {
                root = System.Environment.GetFolderPath(System.Environment.SpecialFolder.MyDocuments);
            }

            Java.IO.File myDir = new Java.IO.File(root + "/Syncfusion");

            myDir.Mkdir();

            Java.IO.File file = new Java.IO.File(myDir, fileName);

            if (file.Exists()) file.Delete();

            try
            {
                FileOutputStream outs = new FileOutputStream(file);
                outs.Write(stream.ToArray());
                outs.Flush();
                outs.Close();
            }
            catch (Exception e)
            {
            }

            if (file.Exists())
            {
                Android.Net.Uri path = Android.Net.Uri.FromFile(file);
                string extension = Android.Webkit.MimeTypeMap.GetFileExtensionFromUrl(Android.Net.Uri.FromFile(file).ToString());
                string mimeType = Android.Webkit.MimeTypeMap.Singleton.GetMimeTypeFromExtension(extension);
                Intent intent = new Intent(Intent.ActionView);
                intent.SetDataAndType(path, mimeType);
                Forms.Context.StartActivity(Intent.CreateChooser(intent, "Choose App"));
            }

            return false;
        }
    }
}